summaryrefslogtreecommitdiff
path: root/plugins/vi-mode
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2021-01-18 13:16:40 -0700
committerTuowen Zhao <ztuowen@gmail.com>2021-01-18 13:16:40 -0700
commitc6e754a3119b7273a57f0cfed38e85303662d26b (patch)
treec50ae3c6b0271ec88e964d3a57199ea37e63bf0b /plugins/vi-mode
parentfb45741fc1dbd40dd2be72bc35a28c6ee8f3f7a5 (diff)
parentefcbd9f3480a28ec69c607c46adcbfd8d230ac9f (diff)
downloadzsh-c6e754a3119b7273a57f0cfed38e85303662d26b.tar.gz
zsh-c6e754a3119b7273a57f0cfed38e85303662d26b.tar.bz2
zsh-c6e754a3119b7273a57f0cfed38e85303662d26b.zip
Merge remote-tracking branch 'origin/master'
Diffstat (limited to 'plugins/vi-mode')
-rw-r--r--plugins/vi-mode/README.md84
-rw-r--r--plugins/vi-mode/vi-mode.plugin.zsh117
2 files changed, 158 insertions, 43 deletions
diff --git a/plugins/vi-mode/README.md b/plugins/vi-mode/README.md
index 8519a5592..b59d5f279 100644
--- a/plugins/vi-mode/README.md
+++ b/plugins/vi-mode/README.md
@@ -1,34 +1,72 @@
-vi-mode
-=======
+# vi-mode plugin
+
This plugin increase `vi-like` zsh functionality.
+To use it, add `vi-mode` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... vi-mode)
+```
+
+## Settings
+
+- `VI_MODE_RESET_PROMPT_ON_MODE_CHANGE`: controls whether the prompt is redrawn when
+ switching to a different input mode. If this is unset, the mode indicator will not
+ be updated when changing to a different mode.
+ Set it to `true` to enable it. For example:
+
+ ```zsh
+ VI_MODE_RESET_PROMPT_ON_MODE_CHANGE=true
+ ```
+
+ The default value is unset, unless `vi_mode_prompt_info` is used, in which case it'll
+ automatically be set to `true`.
+
+- `VI_MODE_SET_CURSOR`: controls whether the cursor style is changed when switching
+ to a different input mode. Set it to `true` to enable it (default: unset):
+
+ ```zsh
+ VI_MODE_SET_CURSOR=true
+ ```
+
+- `MODE_INDICATOR`: controls the string displayed when the shell is in normal mode.
+ See [Mode indicator](#mode-indicator) for details.
+
+## Mode indicator
+
+*Normal mode* is indicated with a red `<<<` mark at the right prompt, when it
+hasn't been defined by theme.
+
+You can change this indicator by setting the `MODE_INDICATOR` variable. This setting
+supports Prompt Expansion sequences. For example:
+
+```zsh
+MODE_INDICATOR="%F{yellow}+%f"
+```
+
+You can also use the `vi_mode_prompt_info` function in your prompt, which will display
+this mode indicator.
+
+## Key bindings
+
Use `ESC` or `CTRL-[` to enter `Normal mode`.
+NOTE: some of these key bindings are set by zsh by default when using a vi-mode keymap.
-History
--------
+### History
- `ctrl-p` : Previous command in history
- `ctrl-n` : Next command in history
- `/` : Search backward in history
- `n` : Repeat the last `/`
+### Vim edition
-Mode indicators
----------------
-
-*Normal mode* is indicated with red `<<<` mark at the right prompt, when it
-wasn't defined by theme.
+- `vv` : Edit current command line in Vim
+NOTE: this used to be bound to `v`. That is now the default (`visual-mode`)
-Vim edition
------------
-
-- `v` : Edit current command line in Vim
-
-
-Movement
---------
+### Movement
- `$` : To the end of the line
- `^` : To the first non-blank character of the line
@@ -46,9 +84,7 @@ Movement
- `;` : Repeat latest f, t, F or T [count] times
- `,` : Repeat latest f, t, F or T in opposite direction
-
-Insertion
----------
+### Insertion
- `i` : Insert text before the cursor
- `I` : Insert text before the first character in the line
@@ -57,9 +93,7 @@ Insertion
- `o` : Insert new command line below the current one
- `O` : Insert new command line above the current one
-
-Delete and Insert
------------------
+### Delete and Insert
- `ctrl-h` : While in *Insert mode*: delete character before the cursor
- `ctrl-w` : While in *Insert mode*: delete word before the cursor
@@ -71,5 +105,5 @@ Delete and Insert
- `C` : Delete to the end of the line and start insert
- `r{char}` : Replace the character under the cursor with {char}
- `R` : Enter replace mode: Each character replaces existing one
-- `x` : Delete [count] characters under and after the cursor
-- `X` : Delete [count] characters before the cursor
+- `x` : Delete `count` characters under and after the cursor
+- `X` : Delete `count` characters before the cursor
diff --git a/plugins/vi-mode/vi-mode.plugin.zsh b/plugins/vi-mode/vi-mode.plugin.zsh
index c91ba05ba..7f14961ad 100644
--- a/plugins/vi-mode/vi-mode.plugin.zsh
+++ b/plugins/vi-mode/vi-mode.plugin.zsh
@@ -1,32 +1,73 @@
+# Control whether to force a redraw on each mode change.
+#
+# Resetting the prompt on every mode change can cause lag when switching modes.
+# This is especially true if the prompt does things like checking git status.
+#
+# Set to "true" to force the prompt to reset on each mode change.
+# Unset or set to any other value to do the opposite.
+#
+# The default is not to reset, unless we're showing the mode in RPS1.
+typeset -g VI_MODE_RESET_PROMPT_ON_MODE_CHANGE
+# Control whether to change the cursor style on mode change.
+#
+# Set to "true" to change the cursor on each mode change.
+# Unset or set to any other value to do the opposite.
+typeset -g VI_MODE_SET_CURSOR
+
+typeset -g VI_KEYMAP=main
+
+function _vi-mode-set-cursor-shape-for-keymap() {
+ [[ "$VI_MODE_SET_CURSOR" = true ]] || return
+
+ # https://vt100.net/docs/vt510-rm/DECSCUSR
+ local _shape=0
+ case "${1:-${VI_KEYMAP:-main}}" in
+ main) _shape=6 ;; # vi insert: line
+ viins) _shape=6 ;; # vi insert: line
+ isearch) _shape=6 ;; # inc search: line
+ command) _shape=6 ;; # read a command name
+ vicmd) _shape=2 ;; # vi cmd: block
+ visual) _shape=2 ;; # vi visual mode: block
+ viopp) _shape=0 ;; # vi operation pending: blinking block
+ *) _shape=0 ;;
+ esac
+ printf $'\e[%d q' "${_shape}"
+}
+
# Updates editor information when the keymap changes.
function zle-keymap-select() {
# update keymap variable for the prompt
- VI_KEYMAP=$KEYMAP
+ typeset -g VI_KEYMAP=$KEYMAP
- zle reset-prompt
- zle -R
+ if [[ "${VI_MODE_RESET_PROMPT_ON_MODE_CHANGE:-}" = true ]]; then
+ zle reset-prompt
+ zle -R
+ fi
+ _vi-mode-set-cursor-shape-for-keymap "${VI_KEYMAP}"
}
-
zle -N zle-keymap-select
-function vi-accept-line() {
- VI_KEYMAP=main
- zle accept-line
+# These "echoti" statements were originally set in lib/key-bindings.zsh
+# Not sure the best way to extend without overriding.
+function zle-line-init() {
+ typeset -g VI_KEYMAP=main
+ (( ! ${+terminfo[smkx]} )) || echoti smkx
+ _vi-mode-set-cursor-shape-for-keymap "${VI_KEYMAP}"
}
+zle -N zle-line-init
-zle -N vi-accept-line
-
+function zle-line-finish() {
+ (( ! ${+terminfo[rmkx]} )) || echoti rmkx
+ _vi-mode-set-cursor-shape-for-keymap default
+}
+zle -N zle-line-finish
bindkey -v
-# use custom accept-line widget to update $VI_KEYMAP
-bindkey -M vicmd '^J' vi-accept-line
-bindkey -M vicmd '^M' vi-accept-line
-
-# allow v to edit the command line (standard behaviour)
+# allow vv to edit the command line (standard behaviour)
autoload -Uz edit-command-line
zle -N edit-command-line
-bindkey -M vicmd 'v' edit-command-line
+bindkey -M vicmd 'vv' edit-command-line
# allow ctrl-p, ctrl-n for navigate history (standard behaviour)
bindkey '^P' up-history
@@ -45,16 +86,56 @@ bindkey '^s' history-incremental-search-forward
bindkey '^a' beginning-of-line
bindkey '^e' end-of-line
+function wrap_clipboard_widgets() {
+ # NB: Assume we are the first wrapper and that we only wrap native widgets
+ # See zsh-autosuggestions.zsh for a more generic and more robust wrapper
+ local verb="$1"
+ shift
+
+ local widget
+ local wrapped_name
+ for widget in "$@"; do
+ wrapped_name="_zsh-vi-${verb}-${widget}"
+ if [ "${verb}" = copy ]; then
+ eval "
+ function ${wrapped_name}() {
+ zle .${widget}
+ printf %s \"\${CUTBUFFER}\" | clipcopy 2>/dev/null || true
+ }
+ "
+ else
+ eval "
+ function ${wrapped_name}() {
+ CUTBUFFER=\"\$(clippaste 2>/dev/null || echo \$CUTBUFFER)\"
+ zle .${widget}
+ }
+ "
+ fi
+ zle -N "${widget}" "${wrapped_name}"
+ done
+}
+
+wrap_clipboard_widgets copy vi-yank vi-yank-eol vi-backward-kill-word vi-change-whole-line vi-delete
+wrap_clipboard_widgets paste vi-put-{before,after}
+unfunction wrap_clipboard_widgets
+
# if mode indicator wasn't setup by theme, define default
-if [[ "$MODE_INDICATOR" == "" ]]; then
- MODE_INDICATOR="%{$fg_bold[red]%}<%{$fg[red]%}<<%{$reset_color%}"
+if [[ -z "$MODE_INDICATOR" ]]; then
+ MODE_INDICATOR='%B%F{red}<%b<<%f'
fi
function vi_mode_prompt_info() {
+ # If we're using the prompt to display mode info, and we haven't explicitly
+ # disabled "reset prompt on mode change", then set it here.
+ #
+ # We do that here instead of the `if` statement below because the user may
+ # set RPS1/RPROMPT to something else in their custom config.
+ : "${VI_MODE_RESET_PROMPT_ON_MODE_CHANGE:=true}"
+
echo "${${VI_KEYMAP/vicmd/$MODE_INDICATOR}/(main|viins)/}"
}
# define right prompt, if it wasn't defined by a theme
-if [[ "$RPS1" == "" && "$RPROMPT" == "" ]]; then
+if [[ -z "$RPS1" && -z "$RPROMPT" ]]; then
RPS1='$(vi_mode_prompt_info)'
fi